;Written by Harold E. Davis    4-13-92    414-278-0100
;CGRID V1.0
;Copyright 1992 Harold E. Davis
;
;Creates ceiling grids on layer EECEILING using lines.
;
(defun hderr(s)
(command"undo""back""layer""s"lay"""setvar""snapbase""0,0")
(setq *error* err)
(foreach a(err lay xlist ylist pt poly ent xcoord ycoord xmax xmin xmed ymax ymin ymed ang wid len ss pt2)(setq a nil))
(if(= s "Function cancelled")
(princ"\nError: Function cancelled - Program ABORTED.")
(princ(strcat "\nError: " s " - Program ABORTED.")))
(prin1))
;
(defun C:CGRID(/ err lay xlist ylist pt poly ent xcoord ycoord xmax xmin xmed ymax ymin ymed ang wid len ss pt2)
(setvar"menuecho"1)(setvar"cmdecho"0)(command"undo""m")
(setq err *error* *error* hderr lay(getvar"clayer")xlist nil ylist nil)
(command"layer""m""dash2l""""pline"(getvar"viewctr")"w"(/(getvar"viewsize")150)"""@0,0""""erase""l""")
(initget 1)
(setq pt(getpoint"\nDraw a pline around the room you want to grid."))
(command"pline"pt)
(while pt
(setq pt(getpoint pt"\nEnter next point, or return to close: "))
(if(or(not pt)(= pt "c"))
(progn(command"close")(setq pt nil))
(command pt)))
(setq poly(cdar(entget(entlast)))ent(cdar(entget(entnext poly))))
(while(=(cdr(assoc 0(entget ent)))"VERTEX")
(setq xcoord(list(cadr(assoc 10(entget ent))))xlist(append xlist xcoord)
ycoord(list(caddr(assoc 10(entget ent))))ylist(append ylist ycoord)
ent(cdar(entget(entnext ent)))))
(setq xmax(apply 'max xlist)xmin(apply 'min xlist)xmed(/(+ xmax xmin)2)
ymax(apply 'max ylist)ymin(apply 'min ylist)ymed(/(+ ymax ymin)2)
pt(list xmed ymed))
(setq ang(getangle pt"\nEnter the grid rotation angle.  <0>: "))
(if(= ang NIL)(setq ang 0)(setq ang(/(* ang 180)pi)))
(initget 1)
(setq wid(getdist"\nEnter the width direction grid spacing: "))
(initget 1)
(setq len(getdist"\nEnter the length direction grid spacing: ")ss(ssadd))
(setvar"snapbase"pt)
(command"layer""m""eeceiling""")
(command"hatch""u"ang len"n"poly"")
(ssadd(entlast)ss)
(command"hatch""u"(+ ang 90)wid"n"poly"")
(ssadd(entlast)ss)
(command"point"pt)
(ssadd(entlast)ss)
(prompt"\nThe ceiling grid has been drawn with grid lines at the center of the room.")
(setq pt2(getpoint pt"\nAdjust ceiling grid location using @X,Y; @distance<degrees; or RETURN for as is. "))
(if pt2(command"move"ss""pt pt2))
(setq pt(cdr(assoc 10(entget(entlast)))))
(setvar"snapbase"pt)
(command"pline"pt"w"0 0"@0,0""")
(ssadd(entlast)ss)
(command"erase"ss"""hatch""*u"ang len"n"poly"""hatch""*u"(+ ang 90)wid"n"poly"""erase"poly"""redraw")
(command"layer""s"lay"""setvar""snapbase""0,0")
(prompt"\nCeiling grid construction completed.")
(prin1))
